"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _getIterator2 = _interopRequireDefault(require("@babel/runtime/core-js/get-iterator"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _promise = _interopRequireDefault(require("@babel/runtime/core-js/promise"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _del = _interopRequireDefault(require("del"));

var _recursiveCopy = _interopRequireDefault(require("recursive-copy"));

var _mkdirpThen = _interopRequireDefault(require("mkdirp-then"));

var _walk = _interopRequireDefault(require("walk"));

var _path2 = require("path");

var _fs = require("fs");

var _config = _interopRequireDefault(require("./config"));

var _constants = require("../lib/constants");

var _render = require("./render");

var _utils = require("./utils");

var _asset = require("../lib/asset");

var envConfig = _interopRequireWildcard(require("../lib/runtime-config"));

function _default(_x, _x2, _x3) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(dir, options, configuration) {
    var nextConfig, nextDir, buildId, pagesManifest, pages, defaultPathMap, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _page2, outDir, exportPathMap, exportPaths, renderOpts, serverRuntimeConfig, publicRuntimeConfig, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _path, _exportPathMap$_path, _page3, _exportPathMap$_path$, query, req, res, htmlFilename, baseDir, htmlFilepath, html, log;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            log = function _ref3(message) {
              if (options.silent) return;
              console.log(message);
            };

            dir = (0, _path2.resolve)(dir);
            nextConfig = configuration || (0, _config.default)(_constants.PHASE_EXPORT, dir);
            nextDir = (0, _path2.join)(dir, nextConfig.distDir);
            log("> using build directory: ".concat(nextDir));

            if (!(0, _fs.existsSync)(nextDir)) {
              console.error("Build directory ".concat(nextDir, " does not exist. Make sure you run \"next build\" before running \"next start\" or \"next export\"."));
              process.exit(1);
            }

            buildId = (0, _fs.readFileSync)((0, _path2.join)(nextDir, 'BUILD_ID'), 'utf8');
            pagesManifest = require((0, _path2.join)(nextDir, 'dist', _constants.PAGES_MANIFEST));
            pages = (0, _keys.default)(pagesManifest);
            defaultPathMap = {};
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 13;
            _iterator = (0, _getIterator2.default)(pages);

          case 15:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 23;
              break;
            }

            _page2 = _step.value;

            if (!(_page2 === '/_document')) {
              _context2.next = 19;
              break;
            }

            return _context2.abrupt("continue", 20);

          case 19:
            defaultPathMap[_page2] = {
              page: _page2
            };

          case 20:
            _iteratorNormalCompletion = true;
            _context2.next = 15;
            break;

          case 23:
            _context2.next = 29;
            break;

          case 25:
            _context2.prev = 25;
            _context2.t0 = _context2["catch"](13);
            _didIteratorError = true;
            _iteratorError = _context2.t0;

          case 29:
            _context2.prev = 29;
            _context2.prev = 30;

            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }

          case 32:
            _context2.prev = 32;

            if (!_didIteratorError) {
              _context2.next = 35;
              break;
            }

            throw _iteratorError;

          case 35:
            return _context2.finish(32);

          case 36:
            return _context2.finish(29);

          case 37:
            // Initialize the output directory
            outDir = options.outdir;
            _context2.next = 40;
            return (0, _del.default)((0, _path2.join)(outDir, '*'));

          case 40:
            _context2.next = 42;
            return (0, _mkdirpThen.default)((0, _path2.join)(outDir, '_next', buildId));

          case 42:
            if (!(0, _fs.existsSync)((0, _path2.join)(dir, 'static'))) {
              _context2.next = 46;
              break;
            }

            log('  copying "static" directory');
            _context2.next = 46;
            return (0, _recursiveCopy.default)((0, _path2.join)(dir, 'static'), (0, _path2.join)(outDir, 'static'), {
              expand: true
            });

          case 46:
            _context2.next = 48;
            return (0, _recursiveCopy.default)((0, _path2.join)(nextDir, 'main.js'), (0, _path2.join)(outDir, '_next', buildId, 'main.js'));

          case 48:
            if (!(0, _fs.existsSync)((0, _path2.join)(nextDir, 'static'))) {
              _context2.next = 52;
              break;
            }

            log('  copying "static build" directory');
            _context2.next = 52;
            return (0, _recursiveCopy.default)((0, _path2.join)(nextDir, 'static'), (0, _path2.join)(outDir, '_next', 'static'));

          case 52:
            if (!(0, _fs.existsSync)((0, _path2.join)(nextDir, 'chunks'))) {
              _context2.next = 58;
              break;
            }

            log('  copying dynamic import chunks');
            _context2.next = 56;
            return (0, _mkdirpThen.default)((0, _path2.join)(outDir, '_next', 'webpack'));

          case 56:
            _context2.next = 58;
            return (0, _recursiveCopy.default)((0, _path2.join)(nextDir, 'chunks'), (0, _path2.join)(outDir, '_next', 'webpack', 'chunks'));

          case 58:
            _context2.next = 60;
            return copyPages(nextDir, outDir, buildId);

          case 60:
            // Get the exportPathMap from the `next.config.js`
            if (typeof nextConfig.exportPathMap !== 'function') {
              console.log('> No "exportPathMap" found in "next.config.js". Generating map from "./pages"');

              nextConfig.exportPathMap =
              /*#__PURE__*/
              function () {
                var _ref2 = (0, _asyncToGenerator2.default)(
                /*#__PURE__*/
                _regenerator.default.mark(function _callee(defaultMap) {
                  return _regenerator.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          return _context.abrupt("return", defaultMap);

                        case 1:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, this);
                }));

                return function (_x4) {
                  return _ref2.apply(this, arguments);
                };
              }();
            }

            _context2.next = 63;
            return nextConfig.exportPathMap(defaultPathMap);

          case 63:
            exportPathMap = _context2.sent;
            exportPaths = (0, _keys.default)(exportPathMap); // Start the rendering process

            renderOpts = {
              dir: dir,
              dist: nextConfig.distDir,
              buildId: buildId,
              nextExport: true,
              assetPrefix: nextConfig.assetPrefix.replace(/\/$/, ''),
              dev: false,
              staticMarkup: false,
              hotReloader: null,
              availableChunks: (0, _utils.getAvailableChunks)(dir, nextConfig.distDir)
            };
            serverRuntimeConfig = nextConfig.serverRuntimeConfig, publicRuntimeConfig = nextConfig.publicRuntimeConfig;

            if (publicRuntimeConfig) {
              renderOpts.runtimeConfig = publicRuntimeConfig;
            }

            envConfig.setConfig({
              serverRuntimeConfig: serverRuntimeConfig,
              publicRuntimeConfig: publicRuntimeConfig
            }); // set the assetPrefix to use for 'next/asset'

            (0, _asset.setAssetPrefix)(renderOpts.assetPrefix); // We need this for server rendering the Link component.

            global.__NEXT_DATA__ = {
              nextExport: true
            };
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context2.prev = 74;
            _iterator2 = (0, _getIterator2.default)(exportPaths);

          case 76:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context2.next = 97;
              break;
            }

            _path = _step2.value;
            log("> exporting path: ".concat(_path));

            if (_path.startsWith('/')) {
              _context2.next = 81;
              break;
            }

            throw new Error("path \"".concat(_path, "\" doesn't start with a backslash"));

          case 81:
            _exportPathMap$_path = exportPathMap[_path], _page3 = _exportPathMap$_path.page, _exportPathMap$_path$ = _exportPathMap$_path.query, query = _exportPathMap$_path$ === void 0 ? {} : _exportPathMap$_path$;
            req = {
              url: _path
            };
            res = {};
            htmlFilename = "".concat(_path).concat(_path2.sep, "index.html");

            if ((0, _path2.extname)(_path) !== '') {
              // If the path has an extension, use that as the filename instead
              htmlFilename = _path;
            } else if (_path === '/') {
              // If the path is the root, just use index.html
              htmlFilename = 'index.html';
            }

            baseDir = (0, _path2.join)(outDir, (0, _path2.dirname)(htmlFilename));
            htmlFilepath = (0, _path2.join)(outDir, htmlFilename);
            _context2.next = 90;
            return (0, _mkdirpThen.default)(baseDir);

          case 90:
            _context2.next = 92;
            return (0, _render.renderToHTML)(req, res, _page3, query, renderOpts);

          case 92:
            html = _context2.sent;
            (0, _fs.writeFileSync)(htmlFilepath, html, 'utf8');

          case 94:
            _iteratorNormalCompletion2 = true;
            _context2.next = 76;
            break;

          case 97:
            _context2.next = 103;
            break;

          case 99:
            _context2.prev = 99;
            _context2.t1 = _context2["catch"](74);
            _didIteratorError2 = true;
            _iteratorError2 = _context2.t1;

          case 103:
            _context2.prev = 103;
            _context2.prev = 104;

            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
              _iterator2.return();
            }

          case 106:
            _context2.prev = 106;

            if (!_didIteratorError2) {
              _context2.next = 109;
              break;
            }

            throw _iteratorError2;

          case 109:
            return _context2.finish(106);

          case 110:
            return _context2.finish(103);

          case 111:
            // Add an empty line to the console for the better readability.
            log('');

          case 112:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[13, 25, 29, 37], [30,, 32, 36], [74, 99, 103, 111], [104,, 106, 110]]);
  }));
  return _ref.apply(this, arguments);
}

function copyPages(nextDir, outDir, buildId) {
  // TODO: do some proper error handling
  return new _promise.default(function (resolve, reject) {
    var nextBundlesDir = (0, _path2.join)(nextDir, 'bundles', 'pages');

    var walker = _walk.default.walk(nextBundlesDir, {
      followLinks: false
    });

    walker.on('file', function (root, stat, next) {
      var filename = stat.name;
      var fullFilePath = "".concat(root).concat(_path2.sep).concat(filename);
      var relativeFilePath = fullFilePath.replace(nextBundlesDir, ''); // We should not expose this page to the client side since
      // it has no use in the client side.

      if (relativeFilePath === "".concat(_path2.sep, "_document.js")) {
        next();
        return;
      }

      var destFilePath = null;

      if (relativeFilePath === "".concat(_path2.sep, "index.js")) {
        destFilePath = (0, _path2.join)(outDir, '_next', buildId, 'page', relativeFilePath);
      } else if (/index\.js$/.test(filename)) {
        var newRelativeFilePath = relativeFilePath.replace("".concat(_path2.sep, "index.js"), '.js');
        destFilePath = (0, _path2.join)(outDir, '_next', buildId, 'page', newRelativeFilePath);
      } else {
        destFilePath = (0, _path2.join)(outDir, '_next', buildId, 'page', relativeFilePath);
      }

      (0, _recursiveCopy.default)(fullFilePath, destFilePath).then(next).catch(reject);
    });
    walker.on('end', resolve);
  });
}